<?php

namespace Drupal\facets_search\Plugin\facets\widget;

use Drupal\facets\Plugin\facets\widget\CheckboxWidget;
use Drupal\facets\FacetInterface;

/**
 * The checkbox / radios widget.
 *
 * @FacetsWidget(
 *   id = "facet_textfield_search",
 *   label = @Translation("List of checkbox with a textfield search"),
 *   description = @Translation("A textfield to search among terms."),
 * )
 */
class FacetTextfieldSearch extends CheckboxWidget {

  /**
   * {@inheritdoc}
   *
   * @SuppressWarnings(PHPMD.CyclomaticComplexity)
   */
  public function build(FacetInterface $facet) {
    $build = parent::build($facet);
    $this->appendWidgetLibrary($build);

    $build['#attributes']['class'][] = 'js-facets-checkbox-links';
    $build['#attached']['library'][] = 'facets/drupal.facets.checkbox-widget';
    $build['#attached']['library'][] = 'facets_search/facets_search';
    return $build;
  }

}
